Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/global.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/global.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/global.f90	(revision 5600)
@@ -6,11 +6,10 @@
 !
 ! DESCRIPTION:
-!> @brief This module defines global variables, and parameters that can't 
-!> be associated with a module
+!> @brief This module defines global variables and parameters.
 !
 !> @author
 !> J.paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
+!> @date November, 2013 - Initial Version
 !
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -22,64 +21,72 @@
    IMPLICIT NONE
 
-   PUBLIC :: dg_fill !< default fill value
-   PUBLIC :: ig_nsep !< number of separator listed
-   PUBLIC :: ig_ncom !< number of comment character listed
-   PUBLIC :: cg_sep  !< list of separator
-   PUBLIC :: cg_com  !< list of comment character
+   PUBLIC :: dp_fill         !< default fill value
+   PUBLIC :: ip_nsep         !< number of separator listed
+   PUBLIC :: ip_ncom         !< number of comment character listed
+   PUBLIC :: cp_sep          !< list of separator
+   PUBLIC :: cp_com          !< list of comment character
 
-   PUBLIC :: ig_npoint
-   PUBLIC :: jp_T
-   PUBLIC :: jp_U
-   PUBLIC :: jp_V
-   PUBLIC :: jp_F
+   PUBLIC :: ip_npoint       !< number of point on ARAKAWA C-grid 
+   PUBLIC :: jp_T            !< indice for T-point on ARAKAWA C-grid
+   PUBLIC :: jp_U            !< indice for U-point on ARAKAWA C-grid
+   PUBLIC :: jp_V            !< indice for V-point on ARAKAWA C-grid
+   PUBLIC :: jp_F            !< indice for F-point on ARAKAWA C-grid
+   PUBLIC :: cp_grid_point   !< list of grid_point character
 
-   PUBLIC :: ig_ndim
-   PUBLIC :: jp_I
-   PUBLIC :: jp_J
-   PUBLIC :: jp_K
-   PUBLIC :: jp_L
+   PUBLIC :: ip_maxdim       !< maximum number of dimension to be used
+   PUBLIC :: jp_I            !< indice for I-direction
+   PUBLIC :: jp_J            !< indice for J-direction
+   PUBLIC :: jp_K            !< indice for K-direction
+   PUBLIC :: jp_L            !< indice for L-direction
+   PUBLIC :: cp_dimorder     !< dimension order
 
-   PUBLIC :: ig_maxvar  !< maximum number of variable
-   PUBLIC :: ig_maxmtx  !< matrix variable maximum dimension
-   PUBLIC :: ig_maxseg  !< maximum number of segment
-   PUBLIC :: ig_ghost   !< number of ghost cell
+   PUBLIC :: ip_maxvar       !< maximum number of variable
+   PUBLIC :: ip_maxmtx       !< matrix variable maximum dimension
+   PUBLIC :: ip_maxseg       !< maximum number of segment
+   PUBLIC :: ip_ghost        !< number of ghost cell
 
-   PUBLIC :: ig_ninterp      !< number of available interpolation method
-   PUBLIC :: cg_interp_list  !< list of interpolation name
+   PUBLIC :: ip_ninterp      !< number of available interpolation method
+   PUBLIC :: cp_interp_list  !< list of interpolation name
    
-   PUBLIC :: ig_nextrap      !< number of available extrapolation method
-   PUBLIC :: cg_extrap_list  !< list of extrapolation name
+   PUBLIC :: ip_nextrap      !< number of available extrapolation method
+   PUBLIC :: cp_extrap_list  !< list of extrapolation name
    
-   PUBLIC :: ig_nfilter      !< number of available filter
-   PUBLIC :: cg_filter_list  !< list of filter name
+   PUBLIC :: ip_nfilter      !< number of available filter
+   PUBLIC :: cp_filter_list  !< list of filter name
 
-   PRIVATE
+   PUBLIC :: ip_ncard        !< number of cardinal point
+   PUBLIC :: cp_card         !< array of cardinal point
+   PUBLIC :: jp_north        !< indice for north boundary
+   PUBLIC :: jp_south        !< indice for south boundary
+   PUBLIC :: jp_east         !< indice for east  boundary
+   PUBLIC :: jp_west         !< indice for west  boundary
+
    ! NOTE_avoid_public_variables_if_possible
 
-   INTEGER(i4)                             , PARAMETER :: ig_maxvar =200   !< maximum number of variable
-   INTEGER(i4)                             , PARAMETER :: ig_maxmtx =100   !< matrix variable maximum dimension (cf create_bathy)
-   INTEGER(i4)                             , PARAMETER :: ig_maxseg =50    !< maximum number of segment for each boundary
+   INTEGER(i4)                             , PARAMETER :: ip_maxvar =200   !< maximum number of variable
+   INTEGER(i4)                             , PARAMETER :: ip_maxmtx =100   !< matrix variable maximum dimension (cf create_bathy)
+   INTEGER(i4)                             , PARAMETER :: ip_maxseg =50    !< maximum number of segment for each boundary
 
-   INTEGER(i4)                             , PARAMETER :: ig_nsep=2  !< number of separator listed
-   CHARACTER(1)     , DIMENSION(ig_nsep)   , PARAMETER :: cg_sep = (/'.','_'/) !< list of separator 
+   INTEGER(i4)                             , PARAMETER :: ip_nsep=2        !< number of separator listed
+   CHARACTER(1)     , DIMENSION(ip_nsep)   , PARAMETER :: cp_sep = (/'.','_'/) !< list of separator 
 
-   INTEGER(i4)                             , PARAMETER :: ig_ncom=2  !< number of comment character listed
-   CHARACTER(1)     , DIMENSION(ig_ncom)   , PARAMETER :: cg_com = (/'#','!'/) !< list of comment character 
+   INTEGER(i4)                             , PARAMETER :: ip_ncom=2        !< number of comment character listed
+   CHARACTER(1)     , DIMENSION(ip_ncom)   , PARAMETER :: cp_com = (/'#','!'/) !< list of comment character 
     
-   INTEGER(i4)                             , PARAMETER :: ig_ghost=1    !< number of ghost cell
+   INTEGER(i4)                             , PARAMETER :: ip_ghost=1       !< number of ghost cell
 
-   INTEGER(i4)                             , PARAMETER :: ig_ninterp=3
-   CHARACTER(LEN=lc), DIMENSION(ig_ninterp), PARAMETER :: cg_interp_list = &
+   INTEGER(i4)                             , PARAMETER :: ip_ninterp=3
+   CHARACTER(LEN=lc), DIMENSION(ip_ninterp), PARAMETER :: cp_interp_list = &
    &  (/ 'nearest', &
    &     'cubic  ', &
    &     'linear '  /)
 
-   INTEGER(i4)                             , PARAMETER :: ig_nextrap=2
-   CHARACTER(LEN=lc), DIMENSION(ig_nextrap), PARAMETER :: cg_extrap_list = &
+   INTEGER(i4)                             , PARAMETER :: ip_nextrap=2
+   CHARACTER(LEN=lc), DIMENSION(ip_nextrap), PARAMETER :: cp_extrap_list = &
    &  (/ 'dist_weight', &
    &     'min_error  ' /)
 
-   INTEGER(i4)                             , PARAMETER :: ig_nfilter=5
-   CHARACTER(LEN=lc), DIMENSION(ig_nfilter), PARAMETER :: cg_filter_list = &
+   INTEGER(i4)                             , PARAMETER :: ip_nfilter=5
+   CHARACTER(LEN=lc), DIMENSION(ip_nfilter), PARAMETER :: cp_filter_list = &
    &  (/ 'butterworth', &
    &     'blackman   ', &
@@ -88,18 +95,35 @@
    &     'gauss      '/)
 
-   REAL(dp)                                , PARAMETER :: dg_fill=NF90_FILL_DOUBLE !< default fill value
-   INTEGER(i4)                             , PARAMETER :: ig_fill=NF90_FILL_INT    !< default fill value
+   REAL(dp)                                , PARAMETER :: dp_fill=NF90_FILL_DOUBLE !< default fill value
 
-   INTEGER(i4)                             , PARAMETER :: ig_npoint=4
+   INTEGER(i4)                             , PARAMETER :: ip_npoint=4
    INTEGER(i4)                             , PARAMETER :: jp_T=1
    INTEGER(i4)                             , PARAMETER :: jp_U=2
    INTEGER(i4)                             , PARAMETER :: jp_V=3
    INTEGER(i4)                             , PARAMETER :: jp_F=4
+   CHARACTER(LEN=1), DIMENSION(ip_npoint)  , PARAMETER :: cp_grid_point = &
+   &  (/ 'T', 'U', 'V', 'F' /)
 
-   INTEGER(i4)                             , PARAMETER :: ig_ndim=2
+
+   INTEGER(i4)                             , PARAMETER :: ip_maxdim=4
    INTEGER(i4)                             , PARAMETER :: jp_I=1
    INTEGER(i4)                             , PARAMETER :: jp_J=2
    INTEGER(i4)                             , PARAMETER :: jp_K=3
    INTEGER(i4)                             , PARAMETER :: jp_L=4
+   CHARACTER(LEN=ip_maxdim)                , PARAMETER :: cp_dimorder = 'xyzt' !< dimension order to output
+
+   INTEGER(i4), PARAMETER :: ip_ncard=4
+   CHARACTER(LEN=lc), DIMENSION(ip_ncard), PARAMETER :: cp_card = &
+   &  (/ 'north', &
+   &     'south', &
+   &     'east ', &
+   &     'west ' /)
+
+   INTEGER(i4), PARAMETER :: jp_north=1
+   INTEGER(i4), PARAMETER :: jp_south=2
+   INTEGER(i4), PARAMETER :: jp_east =3
+   INTEGER(i4), PARAMETER :: jp_west =4
+
+
 
 END MODULE global
Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/grid.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5600)
@@ -6,15 +6,213 @@
 !
 ! DESCRIPTION:
-!> @brief grid manager <br/>
+!> @brief This module is grid manager.
 !>
 !> @details
-!> 
+!>    to get NEMO pivot point index:<br/>
+!> @code
+!>    il_pivot=grid_get_pivot(td_file)
+!> @endcode
+!>       - il_pivot is NEMO pivot point index F(0), T(1)
+!>       - td_file is mpp structure 
+!>
+!>    to get NEMO periodicity index:<br/>
+!> @code
+!>    il_perio=grid_get_perio(td_file)
+!> @endcode
+!>       - il_perio is NEMO periodicity index (0,1,2,3,4,5,6)
+!>       - td_file is mpp structure
+!>
+!>    to check domain validity:<br/>
+!> @code
+!>    CALL grid_check_dom(td_coord, id_imin, id_imax, id_jmin, id_jmax)
+!> @endcode
+!>       - td_coord is coordinates mpp structure
+!>       - id_imin is i-direction lower left  point indice
+!>       - id_imax is i-direction upper right point indice
+!>       - id_jmin is j-direction lower left  point indice
+!>       - id_jmax is j-direction upper right point indice
+!>
+!>    to get closest coarse grid indices of fine grid domain:<br/>
+!> @code
+!>    il_index(:,:)=grid_get_coarse_index(td_coord0, td_coord1,
+!>                                      [id_rho,] [cd_point])
+!> @endcode
+!>    or 
+!> @code
+!>    il_index(:,:)=grid_get_coarse_index(td_lon0, td_lat0, td_coord1,
+!>                                      [id_rho,] [cd_point])
+!> @endcode
+!>    or
+!> @code
+!>    il_index(:,:)=grid_get_coarse_index(td_coord0, td_lon1, td_lat1,
+!>                                      [id_rho,] [cd_point])
+!> @endcode
+!>    or
+!> @code
+!>    il_index(:,:)=grid_get_coarse_index(td_lon0, td_lat0, td_lon1, td_lat1,
+!>                                      [id_rho,] [cd_point])
+!> @endcode
+!>       - il_index(:,:) is  coarse grid indices (/ (/ imin0, imax0 /), 
+!> (/ jmin0, jmax0 /) /)
+!>       - td_coord0 is coarse grid coordinate mpp structure 
+!>       - td_coord1 is fine grid coordinate mpp structure
+!>       - td_lon0 is coarse grid longitude variable structure 
+!>       - td_lat0 is coarse grid latitude  variable structure 
+!>       - td_lon1 is fine   grid longitude variable structure 
+!>       - td_lat1 is fine   grid latitude  variable structure 
+!>       - id_rho is array of refinment factor (default 1)
+!>       - cd_point is Arakawa grid point (default 'T')
+!>
+!>    to know if grid is global:<br/>
+!> @code
+!>    ll_global=grid_is_global(td_lon, td_lat)
+!> @endcode
+!>       - td_lon is longitude variable structure
+!>       - td_lat is latitude variable structure
+!>   
+!>    to know if grid contains north fold:<br/>
+!> @code
+!>    ll_north=grid_is_north_fold(td_lat)
+!> @endcode
+!>       - td_lat is latitude variable structure    
+!>
+!>    to get coarse grid indices of the closest point from one fine grid 
+!> point:<br/>
+!> @code
+!>    il_index(:)=grid_get_closest(dd_lon0(:,:), dd_lat0(:,:), dd_lon1, dd_lat1)
+!> @endcode
+!>       - il_index(:) is  coarse grid indices (/ i0, j0 /)
+!>       - dd_lon0 is coarse grid array of longitude value (real(8))
+!>       - dd_lat0 is coarse grid array of latitude  value (real(8))
+!>       - dd_lon1 is fine grid longitude value (real(8))
+!>       - dd_lat1 is fine grid latitude  value (real(8))
+!>
+!>    to compute distance between a point A and grid points:<br/>
+!> @code
+!>    il_dist(:,:)=grid_distance(dd_lon, dd_lat, dd_lonA, dd_latA)
+!> @endcode
+!>       - il_dist(:,:) is array of distance between point A and grid points
+!>       - dd_lon is array of longitude value (real(8))
+!>       - dd_lat is array of longitude value (real(8))
+!>       - dd_lonA is longitude of point A (real(8))
+!>       - dd_latA is latitude  of point A (real(8))
+!>
+!>    to get offset between fine grid and coarse grid:<br/> 
+!> @code
+!>    il_offset(:,:)=grid_get_fine_offset(td_coord0, 
+!>                                        id_imin0, id_jmin0, id_imax0, id_jmax0,
+!>                                        td_coord1
+!>                                        [,id_rho] [,cd_point])
+!> @endcode
+!>    or
+!> @code
+!>    il_offset(:,:)=grid_get_fine_offset(dd_lon0, dd_lat0, 
+!>                                        id_imin0, id_jmin0,id_imax0, id_jmax0,
+!>                                        td_coord1 
+!>                                        [,id_rho] [,cd_point])
+!> @endcode
+!>    or
+!> @code
+!>    il_offset(:,:)=grid_get_fine_offset(td_coord0, 
+!>                                        id_imin0, id_jmin0, id_imax0, id_jmax0,
+!>                                        dd_lon1, dd_lat1 
+!>                                        [,id_rho] [,cd_point])
+!> @endcode
+!>    or
+!> @code
+!>    il_offset(:,:)=grid_get_fine_offset(dd_lon0, dd_lat0,
+!>                                        id_imin0, id_jmin0, id_imax0, id_jmax0,
+!>                                        dd_lon1, dd_lat1
+!>                                        [,id_rho] [,cd_point])
+!> @endcode
+!>       - il_offset(:,:) is offset array 
+!>    (/ (/ i_offset_left, i_offset_right /), (/ j_offset_lower, j_offset_upper /) /)
+!>       - td_coord0 is coarse grid coordinate mpp structure 
+!>       - dd_lon0  is coarse grid longitude array (real(8))
+!>       - dd_lat0  is coarse grid latitude  array (real(8))
+!>       - id_imin0 is coarse grid lower left  corner i-indice of fine grid 
+!> domain
+!>       - id_jmin0 is coarse grid lower left  corner j-indice of fine grid 
+!> domain
+!>       - id_imax0 is coarse grid upper right corner i-indice of fine grid 
+!> domain
+!>       - id_jmax0 is coarse grid upper right corner j-indice of fine grid 
+!> domain
+!>       - td_coord1 is fine grid coordinate mpp structure
+!>       - dd_lon1  is fine   grid longitude array (real(8))
+!>       - dd_lat1  is fine   grid latitude  array (real(8))
+!>       - id_rho is array of refinment factor (default 1)
+!>       - cd_point is Arakawa grid point (default 'T')
+!>
+!>    to check fine and coarse grid coincidence:<br/>
+!> @code
+!>    CALL grid_check_coincidence(td_coord0, td_coord1, 
+!>                                id_imin0, id_imax0, id_jmin0, id_jmax0
+!>                                [,id_rho])
+!> @endcode
+!>       - td_coord0 is coarse grid coordinate mpp structure
+!>       - td_coord1 is fine   grid coordinate mpp structure
+!>       - id_imin0  is coarse grid lower left  corner i-indice of fine grid 
+!> domain
+!>       - id_imax0  is coarse grid upper right corner i-indice of fine grid 
+!> domain
+!>       - id_jmin0  is coarse grid lower left  corner j-indice of fine grid 
+!> domain
+!>       - id_jmax0  is coarse grid upper right corner j-indice of fine grid 
+!> domain 
+!>       - id_rho    is array of refinement factor (default 1)
+!>
+!>    to add ghost cell at boundaries:<br/>
+!> @code
+!>    CALL grid_add_ghost(td_var, id_ghost)
+!> @endcode
+!>       - td_var is array of variable structure
+!>       - id_ghost is 2D array of ghost cell factor
+!>
+!>    to delete ghost cell at boundaries:<br/>
+!> @code
+!>    CALL grid_del_ghost(td_var, id_ghost)
+!> @endcode
+!>       - td_var is array of variable structure
+!>       - id_ghost is 2D array of ghost cell factor
+!>
+!>    to get ghost cell factor (use or not):<br/>
+!> @code
+!>    il_factor(:)= grid_get_ghost( td_var )
+!> @endcode
+!>    or
+!> @code
+!>    il_factor(:)= grid_get_ghost( td_mpp )
+!> @endcode
+!>       - il_factor(:) is  array of ghost cell factor (0 or 1)
+!>       - td_var  is variable structure
+!>       - td_mpp is mpp sturcture
+!>
+!>    to compute closed sea domain:<br/>
+!> @code
+!>    il_mask(:,:)=grid_split_domain(td_var, [id_level])
+!> @endcode
+!>       - il_mask(:,:) is domain mask
+!>       - td_var is variable strucutre
+!>       - id_level is level to be used [optional] 
+!>
+!>    to fill small closed sea with _FillValue:<br/>
+!> @code
+!>    CALL grid_fill_small_dom(td_var, id_mask, [id_minsize])
+!> @endcode
+!>       - td_var  is variable structure
+!>       - id_mask is domain mask (from grid_split_domain)
+!>       - id_minsize is minimum size of sea to be kept [optional]
+!>
 !> @author
 !> J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
+!> @date November, 2013 - Initial Version
+!> @date September, 2014
+!> - add header
+!> @date October, 2014
+!> - use mpp file structure instead of file
 !
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!> @todo
 !----------------------------------------------------------------------
 MODULE grid
@@ -24,14 +222,15 @@
    USE global                          ! global parameter
    USE phycst                          ! physical constant
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE file                            ! file manager
+   USE att                             ! attribute manager
    USE var                             ! variable manager
    USE dim                             ! dimension manager
-   USE dom                             ! domain manager
    USE iom                             ! I/O manager
    USE mpp                             ! MPP manager
+   USE dom                             ! domain manager
    USE iom_mpp                         ! MPP I/O manager
+   USE iom_dom                         ! DOM I/O manager
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
